//
//  SWCircle.m
//  SWGameLib
//
//
//  Copyright (c) 2010 Sangwoo Im
//
//  Permission is hereby granted, free of charge, to any person obtaining a copy
//  of this software and associated documentation files (the "Software"), to deal
//  in the Software without restriction, including without limitation the rights
//  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//  copies of the Software, and to permit persons to whom the Software is
//  furnished to do so, subject to the following conditions:
//
//  The above copyright notice and this permission notice shall be included in
//  all copies or substantial portions of the Software.
//
//  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//  THE SOFTWARE.
//  
//  Created by Sangwoo Im on 9/6/10.
//  Copyright 2010 Sangwoo Im. All rights reserved.
//

#import "SWCircle.h"
#import "CGPointExtension.h"

@implementation SWCircle

-(id)initWithRadius:(CGFloat)r {
    if ((self = [super initWithTemplate:nil])) {
        cpShape *s;
        cpBody  *b;
        
        b = cpBodyNew(1, cpMomentForCircle(1, 0, r, ccp(0,0)));
        s = cpCircleShapeNew(b, r, ccp(0,0));
        
        s->data = self;
        
        s->e = 0.0f;
        s->u = 0.0f;
        _shape = s;
    }
    return self;
}

-(void)update {
    
}

#pragma mark -
#pragma mark Collisions

-(BOOL)beginCollisionWithPoint:(CGPoint)p object:(SWPhysicsObject *)obj {
    return YES;
}
-(BOOL)afterEffectsExist:(SWPhysicsObject *)obj {
    return YES;
}
@end
