//
//  SWDebug.h
//  SWGameLib
//
//
//  Copyright (c) 2010 Sangwoo Im
//
//  Permission is hereby granted, free of charge, to any person obtaining a copy
//  of this software and associated documentation files (the "Software"), to deal
//  in the Software without restriction, including without limitation the rights
//  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//  copies of the Software, and to permit persons to whom the Software is
//  furnished to do so, subject to the following conditions:
//
//  The above copyright notice and this permission notice shall be included in
//  all copies or substantial portions of the Software.
//
//  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//  THE SOFTWARE.
//  
//  Created by Sangwoo Im on 5/9/10.
//  Copyright 2010 Sangwoo Im. All rights reserved.
//

/**
 * Assertions and logging used within the library.
 */

#ifdef __OPTIMIZE__
#   define __SW_LOG_DISABLED__
#   define __SW_ASSERT_DISABLED__
#endif

#ifdef __SW_LOG_DISABLED__
#   define NDEBUG
#   define METHOD_ENTER()
#   define METHOD_EXIT()
#   define SWLog(...)
#else
#   define METHOD_ENTER() NSLog(@"%s: %s: Enter",__FILE__,__FUNCTION__)
#   define METHOD_EXIT()  NSLog(@"%s: %s: Exit",__FILE__,__FUNCTION__)
#   define SWLog(...)     NSLog(__VA_ARGS__)
#endif

#ifdef __SW_ASSERT_DISABLED__
#   define SWAssert(...)
#else
#   define SWAssert(...)  NSAssert(__VA_ARGS__)
#endif