//
//  SWEvent.m
//  SWGameLib
//
//
//  Copyright (c) 2010 Sangwoo Im
//
//  Permission is hereby granted, free of charge, to any person obtaining a copy
//  of this software and associated documentation files (the "Software"), to deal
//  in the Software without restriction, including without limitation the rights
//  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//  copies of the Software, and to permit persons to whom the Software is
//  furnished to do so, subject to the following conditions:
//
//  The above copyright notice and this permission notice shall be included in
//  all copies or substantial portions of the Software.
//
//  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//  THE SOFTWARE.
//  
//  Created by Sangwoo Im on 9/27/10.
//  Copyright 2010 Sangwoo Im. All rights reserved.
//

#import "SWEvent.h"


@implementation SWEvent
@synthesize enabled  = _enabled;
@synthesize handler  = _handler;
@synthesize checker  = _checker;
@synthesize eventID  = _eid;

-(id)init {
    if ((self = [super init])) {
        _enabled = YES;
        _handler = nil;
        _checker = nil;
    }
    return self;
}
-(void)dealloc {
    _handler = nil;
    _checker = nil;
    
    [super dealloc];
}
-(void)update {
    if (_enabled) {
        if ([_checker eventShouldHappen:self]) {
            [_handler handleEvent:self];
        }
    }
}
@end
