//
//  SWGameLib.h
//  SWGameLib
//
//  Copyright (c) 2010 Sangwoo Im
//
//  Permission is hereby granted, free of charge, to any person obtaining a copy
//  of this software and associated documentation files (the "Software"), to deal
//  in the Software without restriction, including without limitation the rights
//  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//  copies of the Software, and to permit persons to whom the Software is
//  furnished to do so, subject to the following conditions:
//
//  The above copyright notice and this permission notice shall be included in
//  all copies or substantial portions of the Software.
//
//  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//  THE SOFTWARE.
//  
//  Created by Sangwoo Im on 9/28/10.
//  Copyright 2010 Sangwoo Im. All rights reserved.
//

/**
 * Game Logics
 */
#import "SWDebug.h"
#import "NSMutableArray+Sorting.h"
#import "Util.h"
#import "SWObject.h"
#import "SWDefaultObjectManager.h"
#import "SWObjectTemplates.h"
#import "SWLoadingScene.h"
#import "SWPhysicsObject.h"
#import "SWSensors.h"
#import "SWSteerObject.h"
#import "SWEvent.h"

/**
 * OpenGL Extensions
 */
#import "SWPrimitives.h"

/**
 * Chimpmunk Primitives
 */
#import "SWObjConstraint.h"
#import "SWPinJoint.h"
#import "SWSegment.h"
#import "SWCircle.h"
#import "SWRectangle.h"

/**
 * Cocos2d Extensions
 */
#import "SWLoadingScene.h"
#import "SWSprite.h"
#import "SWScrollView.h"
#import "SWTableView.h"
#import "SWTableViewCell.h"
#import "SWMultiColumnTableView.h"

/**
 * Cocoa async socket library
 */
#import "AsyncSocket.h"
#import "AsyncUdpSocket.h"

/**
 * Networking
 */
#import "SWMessage.h"
#import "Reachability.h"
#import "SWPacket.h"
#import "SWDatagram.h"
#import "SWNetworkObjectManager.h"

/**
 * Object Template Keys
 *
 * You need to use these keys to build your object template database.
 */

#define kSWOSoundEffects @"SoundEffects"
#define kSWOAnimations   @"Animations"
#define kSWOSpriteParent @"SpriteSheet"
#define kSWOSprite       @"Sprite"
#define kSWOData         @"Data"

#define kSWOMass         @"Mass"
#define kSWOFriction     @"Friction"
#define kSWOElasticity   @"Elasticity"
#define kSteerMaxSpeed   @"Speed"

/**
 * Additional Dictionary keys
 */

#define kSWOTemplateKey       @"ClassName"
#define kSWOColState          @"ColState"
#define kSWOColStateBegan     @"ColBegan"
#define kSWOColStatePreSolve  @"ColPreSolve"
#define kSWOColStatePostSolve @"ColPosSolve"
#define kSWOColStateEnd       @"ColEnd"

#define SWLoadClass @"Class"
#define SWLoadBG    @"BackgroundImage"
#define SWLoadTimer @"ProgressBarImage"
#define SWLoadData  @"ClassInitData"
#define SWLoader    @"LoadingObject"

