//
//  SWSegment.m
//  SWGameLib
//
//  Copyright (c) 2010 Sangwoo Im
//
//  Permission is hereby granted, free of charge, to any person obtaining a copy
//  of this software and associated documentation files (the "Software"), to deal
//  in the Software without restriction, including without limitation the rights
//  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//  copies of the Software, and to permit persons to whom the Software is
//  furnished to do so, subject to the following conditions:
//
//  The above copyright notice and this permission notice shall be included in
//  all copies or substantial portions of the Software.
//
//  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//  THE SOFTWARE.
//  
//
//  Created by Sangwoo Im on 9/5/10.
//  Copyright 2010 Sangwoo Im. All rights reserved.
//

#import "SWSegment.h"
#import "chipmunk.h"
#import "SWDebug.h"

@implementation SWSegment

-(id)initWithPoint:(CGPoint)p1 point:(CGPoint)p2 {
    if ((self = [super initWithTemplate:nil])) {
        cpShape *s;
        cpBody  *b;
        
        b = cpBodyNew(INFINITY, INFINITY);
        s = cpSegmentShapeNew(b, p1, p2, 1.0f);
        
        _shape = s;
    }
    return self;
}
-(void)setPosition:(CGPoint)pos {
    SWLog(@"Static shape should not be moved, canceling the operation.");
}
-(void)setRotation:(CGFloat)rot {
    SWLog(@"Static shape should not be rotated, canceling the operation.");
}
-(void)update {
    
}
@end
